---
title: Create Shipping Carrier
slug: api-documentation/create-shipping-carrier
docTags: 
createdAt: 2026-08-27T17:08:07.245Z
---

{
  "id": "iVtZaK0p7n2yuvf9lF6WH",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.upstartcommerce.com/v1/shipping-carrier",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/v1/shipping-carrier"
      }
    ],
    "name": "Create Shipping Carrier",
    "description": "<p>This endpoint allows administrators to create a new shipping carrier with the provided details.</p>\n<p>Authorized permissions:</p>\n<ul>\n<li><code>shipping.carrier.create</code></li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        },
        {
          "kind": "required",
          "name": "x-upstart-tenant",
          "type": "string",
          "description": "Tenant identifier associated with the site this call is for."
        },
        {
          "kind": "optional",
          "name": "x-upstart-site",
          "type": "string",
          "description": "Unique identifier for the site."
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "CreateShippingCarrier",
          "schema": [
            {
              "name": "id",
              "kind": "optional",
              "type": "string",
              "description": "Unique identifier for the shipping carrier. This will be assigned unless it is provided.",
              "example": "usps"
            },
            {
              "name": "name",
              "kind": "required",
              "type": "string",
              "description": "Carrier name.",
              "example": "USPS"
            },
            {
              "name": "siteIds",
              "kind": "required",
              "type": "array",
              "description": "",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "description",
              "kind": "optional",
              "type": "string",
              "description": ""
            },
            {
              "name": "trackingUrl",
              "kind": "optional",
              "type": "string",
              "description": "<p>Tracking URL. If defined, tracking is supported for given carrier. Placeholder for trackingNumber {{trackingNumber}}.</p>",
              "example": "https://tools.usps.com/go/TrackConfirmAction?tRef=fullpage&tLc=2&text28777=&tLabels={{trackingNumber}}."
            },
            {
              "name": "accountNumber",
              "kind": "optional",
              "type": "string",
              "description": "Account number for the carrier."
            }
          ],
          "modelRef": "#/components/schemas/CreateShippingCarrier",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "NoChannelPortalAccess",
          "name": "NoChannelPortalAccess",
          "kind": "optional",
          "type": "http",
          "description": "<p>This authentication is required for clients to interact with any of the management APIs. Similar to 'LoggedIn', it indicates that the user has actually logged into the system, but in this case with a management role.</p>",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "<p>Success-shipping carrier created.</p>",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ShippingCarrier",
            "schema": [
              {
                "name": "id",
                "kind": "required",
                "type": "string",
                "description": "Unique identifier for the shipping carrier. This will be assigned unless it is provided.",
                "example": "usps"
              },
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": "Carrier name",
                "example": "USPS"
              },
              {
                "name": "siteIds",
                "kind": "required",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              },
              {
                "name": "description",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "trackingUrl",
                "kind": "optional",
                "type": "string",
                "description": "<p>Tracking URL. If defined, tracking is supported for given carrier. Placeholder for trackingNumber {{trackingNumber}}</p>",
                "example": "https://tools.usps.com/go/TrackConfirmAction?tRef=fullpage&tLc=2&text28777=&tLabels={{trackingNumber}}"
              },
              {
                "name": "accountNumber",
                "kind": "optional",
                "type": "string",
                "description": "Account number for carrier."
              }
            ],
            "modelRef": "#/components/schemas/ShippingCarrier",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "The request contained information that the server was unable to process. Appropriate errors are provided in the response body.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ValidationErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "optional",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ValidationErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "FEf_ApES7uT1dLmCrswH0",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.upstartcommerce.com/v1/shipping-carrier \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --header 'x-upstart-tenant: string' \\\n     --data '{\n     \"name\": \"USPS\",\n     \"siteIds\": []\n     }'"
        },
        {
          "id": "9S61gkS2wHMxEoN0YtUod",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\nmyHeaders.append(\"x-upstart-tenant\", \"string\");\n\nvar raw = JSON.stringify({\n   \"name\": \"USPS\",\n   \"siteIds\": []\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/v1/shipping-carrier\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "9apCEZJEmLyDgGbtTglqZ",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/v1/shipping-carrier\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest[\"x-upstart-tenant\"] = \"string\"\nrequest.body = JSON.dump({\n   \"name\": \"USPS\",\n   \"siteIds\": []\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "grOIrcLENMgKdSGYVBQvF",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/v1/shipping-carrier\"\n\npayload = json.dumps({\n   \"name\": \"USPS\",\n   \"siteIds\": []\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json',\n   'x-upstart-tenant': 'string'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "FEf_ApES7uT1dLmCrswH0"
    },
    "results": {
      "languages": [
        {
          "id": "WF2hNMY5uLDHNdCbYJRjy",
          "language": "201",
          "code": "// Success-shipping carrier created.\n{\n  \"id\": \"usps\",\n  \"name\": \"USPS\",\n  \"siteIds\": [\n    \"\"\n  ],\n  \"description\": \"\",\n  \"trackingUrl\": \"https://tools.usps.com/go/TrackConfirmAction?tRef=fullpage&tLc=2&text28777=&tLabels={{trackingNumber}}\",\n  \"accountNumber\": \"\"\n}"
        },
        {
          "id": "ZMfYuk8MN-_FOjwnACeio",
          "language": "400",
          "code": "// The request contained information that the server was unable to process. Appropriate errors are provided in the response body.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        },
        {
          "id": "Xyy0foo0AZUZyeGb8536s",
          "language": "401",
          "code": "// The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "WF2hNMY5uLDHNdCbYJRjy"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}